from suplexedlibrary.api.BaseApi import BaseApi
from suplexedlibrary.api.tools.header_tools import get_random_user_agent
from suplexedlibrary.proxies.provider import get_luminati_sync_static_residential
from requests import Session, session
from pprint import pprint


class FlightClubApi(BaseApi):

    def get_google_captcha_token(self) -> str:
        google_key = '6LfC_pgUAAAAAKuGdjhGQKaUylk2vkEngz3C0D6Y'
        url = f'https://www.google.com/recaptcha/api2/userverify?k={google_key}'
        form_data = {
            'v': 'AFBwIe6h0oOL7MOVu88LHld-',
            'c': '03AGdBq25q4ec-ldeYKzPimtl_FpYkHbtyXfoZHUXfw2fqLtZaqWfC4kt2veVf8zesQe9K1Ozsqg6k_YyrD8urvDXh_3knxVosDPfs5qbYhmi_a4Wo8sxrB7aHg6FgivyK2wcIedgt_8WWjeK3Gx1fMbu2UqOa8ooxdPn4Ek_NKKafHQ_20gXf_qp6Bln80JBjUDho6GneDWwXgSk-PFgoqCf9V3D8WFW2NRsJG6opoROgmOxv_BITWTCvrr8hYz1scMISNnqwn9XgHZQsSnCd7BcDh-LmOrkwNDgEICFz-4GQWRJWblajI1Apn_MXALPDcMJ7V-3AVoI9KvGon28ERzDWeDZudALUUIQiMbvoSKSo7FvhsxtsQXT5Cyuyv4y0MS6ZRn-JdK3OAVqewaF-y08loVhUtBDOmZ6sXJqJ557uHc17fYlhnXAWZulI07pfqOUjx8Ww-uGbOpTLGGLSqIqdeOEn6E1svH1ZhTLn6JZhnSnO-7j5v7D85ioEm3Nrn0Z2adzniMqQTCCYDBjSoq3XAiQOSaxerNXbOiciTyeHOJMLIH6rpUVvHo5r6g8b9BU5pv3nc0yT31fQAvu0OgZGzuzD5XR_4bYrUAU4ZcoE3NdIWy10k8vvt5i7oFvlNqHRl_inbsDuyLHJQOjLoIcThzr-UQdoYIQAtQBnAoQJl4ChYAB-LaQsKjKv-sWLloZ4B7OKvgFeCBZ_tUs8lU4UoIIe1QPZVuHGY-WA9a8cqEr-6jFQwoKVS-bN9q-HTNQVXiH6GbiZCr_lt_hnh2iYTTBSh6jjdbhm2zJNJBIgk1XU-4lmapODYVuJaH7bZSEOXRUbh_-OKYsOgzWU9PLZDm1RoNWFF2hlWFq3KTaomxHrS9dAKeyyUrgYQ9frh6FijFyP-Z8loHWcz6PdJdFvQE_2HsXsegHT0n2nuFC8Sh6D2IRdnC5dA1YcvW6jNbCZR0lOZUSQMPgNNRws5AvhuQZSjazsKqP30dDuVzuDgaSTrPjvJvJ4-jqWjh50om3HG2KFIqxPbGfIh6deP4eNKaj7cmNYcOLIPD3by7WT4eygROydc09O9yMV2VPjKyBidU-ZAMOLIIwQc46gfoFaxKRBzyKlS4pvl_M5eSHHEunP9NeDlAmvn77r1iGFGu4LTjZeaX4ycFb1dCnDbHsJlRkqhFAErwTRlaOpXlE88v_Xw0aDN5pD9Gz5Roue0d8xvmgFcG74dxmpxPH7V6i5njrjTHI_h7AjoJVUpmLq5YYaw6_ShAkxpg2ptCrz9qiCeSAUJvX2_ynO1AWcWkahuww6DIE5M4hGNShuhUC3y5Z-UoYolU2-5-Mys5pVW9p0B3cpUAeXJSdCqDmGTdQkGCJklLt1gaL37FIkxrw55ZQMFAQPzJ641STh8XJB7wv4RF4mNdB9d1sKFR96Tr5citZ5zgDuqo-g4UA0lLU0hHzadLL0XYIKILtlyS8OG4u2UNyWBilLSA_IGuFpK6OJvsT_P13TjW7xkUjD35EMmiquPQdJNIJHxTF0iRfLa3rkUdtVhgqWkV8mFEDc_SOU__sxDbBGW7RXhLtcCzQPUOlTEIzORr60qm79pbe7GInyaOkgk45pJPoZn5OxXhwgOIy4PaxaAGNMowUz0QoNh_U6LWZNzlX0D2BWtyRt6ArdUOZoBozTil1SBJdD_ZqOkzX0z9f_s8YFYwIgIaj-z0PzBnq5yqXpZqNrJMyQOG1nXX2SdkP7UwFFnTu2SxqvGQClTSd0jfbifjoTUdbkqDApoxlwZlRtjI3YOZPy9uT_WMHK123n94XeqdjlvhbFY_TkmOOBXwmajMNnNOonbjsZPLGdq6i3mo_avDVrX4lpHo9BQaTj9ZxGTzJIwYLvbIg3SblQzkk5MxT3q3_0_O7MU-0PXza2BbYx6nhZ9MIigrPuh9-VtI3Qo6P65QKDcBEBZmwpGq2Ql8dqDX2HVFxOce-55uOvTJ4l-0eCU49isbL40YdaB-eV2GSswoOUrBMRzh-TZush_A6MLX_DL64tPmbs0PvJv81O5itQGuO-t2uvwjOFqVwg_lD406EqffuGUDbITd30pMnjT3TpiLz8hnI1w7nd2g609ZHx3MgxTWvHJOSQfX1X1Dzpb3fT98N0lOa3Xg3rzL7TRG_OL5tIVkBBaJxLKEXr6VVrZuhJA1WO8G3T4oRmZ6-Y7lGYqfLy7hsHxZkC_bPHBcm2svmp4n5OSBEdO0qgRjB-xlm8TV-9rPyG2hPJtKtk2LZhsYpm1y3GAlkEf9N-bYxQ56kfhYpOPXCWjCOqg1Bd8k_V7nSQ2iolteazJb6c0XVuAcRT58oKd_U-LexXo6G1yvraRC5Ipj4IdKdVB5iMSTw-EW3CdTVbhd39LjBBxGP4kFwxbwLffA',
            'response': 'eyJyZXNwb25zZSI6IiIsInMiOiIiLCJlIjoiZDBpdlROUSJ9',
            't': '596',
            'ct': '596',
            'bg': '!ysygzO1HFW7oPKph-8ddZw1eBPVFJXsHAAAA_lcAAAAHnAP62t_LZ-zLhwXwKo3QaOa_PR1Wh0k-2VvNx1VYekVFwgzA4AtteqaYL557q-Fx_VoOiT117gNOTykmAZDPQyCYyGG_FoX8TCqHO59k54sc_Z7f47UY1G2PTnBDKT1tkjWd09XBCPCAh6y1MPl_aW8b9cqd5sOZqLqDpqWBt3uFglH1-QrPtcHkVuSvtNJBnRsfmZOQYwZYm0t2txetQ2a2XSqpQEZeFRtk2DIM6vJwgk8woFaEQxSHnTUpA6mlq3XNwM45ZBtIgqCbVZxU4-LvKqfwCHzve_fSGxACI3qQFBD8AzPPygtbG-9438JVtKalUZsVIOi65qU2YgvzqVvpkN2AqesAR4RQcAq-aCFli9MJqdzXckC31JQcDBPHag37pEvpTN24uwKvPt1e3862lu7wGSF1Su_bckFl9zZJOy2F85o2hQqCMcZ7-j-1TxXFdvCwKJAhN4CjLW6Tds1dpDQWdwh0zesF6SK1IyKRf0QwG13w6Y51iNKWH0IlMVU7ahwBDmYBD6pR_jizzNSaFDDaAI2DhhvxjEg_qp0uE2bJdtDVN8eO8PckiHa2oQBmj5KGqa0jxEz1Ckwz-ntpE8iuuv51GXUJrEDdvqKe1CMSKCKgQ8wT-UwNxiKry3jVKbu6drwuTwQHHKLUO7qDep3Ws2JNEeb_4xOBfW5qzIKn6GHzxbSG_UHvkDYPdeP8RjeiV5qwEoTan2lNtJvUm_stMwfRy2qtgopJ7JsUGBdFxEkKCIZq5t608Hhe5_KgUb8ahXxnxvWSoWfyYaxPoptqNn0Q4IuNR_7wjxYAy-SuczIE25sUpsIhiOYWy4clvzX7oobxmesUlrfiebFzlPE6wKifmyGIEjRusbDYclONmxjgmGhAn8fzS-kJsdzqldXHDE0mgWuTJbPt7VVwaIM51eabB94WDwUd9P6JhqNTolc9K6YroUsUwhe6NUOnVHolnspbDny6jiGZS0rLd6OL4bFuZPHsIfA_ij-XsEcM8C-9kAeRKvp69-HOiNRjU90-k78UGuQg9akKoy-MUUhV73CceEh-PKHBWVwEMbIOisl7E3O1HSsBV1NcVS4JQ8DKgy-tOfBgs1bqK05Mdm2-WyY0db8TlzeW5Z9MRh67u9h0CaLf_ci5h5rUkwVM4eMrmwBKc2z7cRX9q8nwN1rMEHe1ndDLtmQH98XrvkT2CI56-I3iPh8vdEdI8C-HFbCRhalVGpnCL_cZ3oZ10vkb2G50UEiXIirNnWfm4PNjQ09OLpNZYExT5PjFijDcLq90X948v-5Q4I8O6kcMBC8KetCJ-aFuouGdcbA3bA7v6mlX_7hfDqnAPruekL1-3gsyqtp3f_k_QQ',
        }
        google_headers = {
            'authority': 'www.google.com',
            'method': 'POST',
            'path': '/recaptcha/api2/userverify?k=6LfC_pgUAAAAAKuGdjhGQKaUylk2vkEngz3C0D6Y',
            'scheme': 'https',
            'accept': '*/*',
            'accept-encoding': 'gzip, deflate, br',
            'accept-language': 'en-US,en;q=0.9',
            'cache-control': 'no-cache',
            'content-length': '4419',
            'content-type': 'application/x-www-form-urlencoded;charset=UTF-8',
            'cookie': 'ANID=AHWqTUl7qppAJ2oELdEd8GDP2U0vK-MEJ2TAP4wtky61AzqiQQ1YkzmXINQVCLg7; __Secure-3PSID=zweqpXmik5PxqrXZVpJJazNSQePDRQ_qD7JLf7vxrLYjx5bzpKamYcQhGzebn7CCsMJqnQ.; __Secure-3PAPISID=qTvspbsyk-ZgaIaW/A53bcrt6dVHE6gEFk; NID=204=rPw5UGf1tDsXjBUGDgReiavICx7UNclhoBhvvl6__sRnwVn1K54D7BMN_p1yzxyZ_uxuxCUKHA19VT8stPZMPgxLnd7_7DrxfsVoteOIZ2D9k7sivBGTTRSIJcluxL8E7nD7VKVVzv6XRY7u6pQCYR5A-Gng0GQTSNgnYbcs_fwJr7byeQZNUx5xOV68pSdzrAGzL5lpdkvJmEf1GhSq9RQid398x0jMnnQxdakTVedYOXmBDSebTDO1sGFOLHOoX1Pq2jSFhQ; 1P_JAR=2020-08-03-18',
            'origin': 'https://www.google.com',
            'pragma': 'no-cache',
            'referer': 'https://www.google.com/recaptcha/api2/bframe?hl=en&v=AFBwIe6h0oOL7MOVu88LHld-&k=6LfC_pgUAAAAAKuGdjhGQKaUylk2vkEngz3C0D6Y&cb=qgxf8gyeg2qn',
            'sec-fetch-dest': 'empty',
            'sec-fetch-mode': 'cors',
            'sec-fetch-site': 'same-origin',
            'user-agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36',
            'x-client-data': 'CIm2yQEIo7bJAQjEtskBCKmdygEIhrXKAQiZtcoBCP+8ygEIi7/KAQjnyMoBCOnIygEIkM3KAQ==',
        }
        google_res = self.sess.post(url, form_data, headers=google_headers)

        return google_res.json()

    def get_token(self):
        token = '03AGdBq27vyg5C2l8Uk3ReAfRlxPxdMezkHfjJz1dg6RAM4icxf84zGgxS-dupg-AUYNBR5tKRzq5n8DVFKLcDDrPS-hm-tC4QSdz7H9tIHazbuftv9Wqk2_IfSW8zelnQkJ3iu_EpHVlHj_h5yFm9cTObeFO4UnjbnZJ73rOPQ3YE88jVcAH8QTfahCEnRlJd_rHLzDI0lXqoWJdzh8glnhPkqjc8H19mx2GETkeC6nzyxiGhEmC4Tnmlixzz1YYXfyEYlwGx4E7ddqkNpIdT-j1LAEq-r7MLJTlriQS0Ge6-y680dcXLO-y5WFWFBGjS1sOeveSfW-KnY3juhxpzwdKmnc07ZsWqGeZn2RONAgqMRouaKA4lawlNdHMTbKckl3ICv0JmOaHK6oZVAfh5dkPCzSrHk0oz3A'
        url = f'https://sell.flightclub.com/request_token?token={token}'
        url = 'https://sell.flightclub.com/request_token?token=03AGdBq25ifFUsaKzbNtlScAFrMrU-YLKF3fV9AEBtn9tuEdwCwRKwnC02f2pPBeUoujSgHsfwLNtnSGLmQF77sho_qDTncN1fXVczjswiAWI-BquYjq7YsMzVLgR6c77dNs2tibRojvauv-ic40xWdX4bTCLYeyG9YZ2mRHNe0t8YARZ48he_-XwwPPMecbM2TYBfegK6qPLe_ePlRZXxSYQmOGiYCeYV6w34xt-6jqZnWzUDtvQewGRjqpJ_1AmvPMkmnsHDCgFjUHqcyDrn887ohS64dXRO6ZPMsg4EDaNrEMTDMcrT2c4-bMP0njtVoTYQCpIRmPPi1uedOunDB6G9TqaUX_lCXBa_R0fEzxgio4gZzCuTww6tuNCAM0C3x1cTVmJ3pcgz5Z5JHD2d8pkxPvraLUoGgg'
        headers = {
            'authority': 'sell.flightclub.com',
            'method': 'GET',
            'path': f'/request_token?token={token}',
            'cookie': '__cfduid=d52270f16661bd1c5cebcb0e8272059dd1596458487; _ga=GA1.2.1519448362.1596458488; _gid=GA1.2.13138114.1596458488',
            'scheme': 'https',
            'accept': '*/*',
            'accept-encoding': 'gzip, deflate, br',
            'accept-language': 'en-US,en;q=0.9',
            'referer': 'https://sell.flightclub.com/login?redirect_url=/home',
            'sec-fetch-dest': 'empty',
            'sec-fetch-mode': 'cors',
            'sec-fetch-site': 'same-origin',
            'user-agent': self.user_agent
        }
        response = self.sess.get(url, headers=headers)

        return response.content

    def generate_login(session: Session, account: any):
        pass

    def simple_login(self):
        sess = session()
        user_agent = get_random_user_agent()
        get_headers = {
            'user-agent': user_agent
        }
        home_res = sess.get('https://sell.flightclub.com/', headers=get_headers)
        print(f'home res: {home_res.status_code}')
        login_res = sess.get('https://sell.flightclub.com/login', headers=get_headers)
        print(f'login res: {login_res.status_code}')
        token_url = 'https://sell.flightclub.com/request_token?token='
        token_res = sess.get(token_url, headers=get_headers)
        url = 'https://sell.flightclub.com/api/me/login'
        token_str = token_res.content.decode('utf-8')
        print(f'logging in with token: {token_str}')
        login_response = sess.post(
            url,
            headers={
                'authority': 'sell.flightclub.com',
                'method': 'POST',
                'path': '/api/me/login',
                'scheme': 'https',
                'accept': '*/*',
                'accept-encoding': 'gzip, deflate, br',
                'accept-language': 'en-US,en;q=0.9',
                'cache-control': 'no-cache',
                'content-length': '248',
                'content-type': 'application/json',
                'cookie': '__cfduid=d730f9ea65c514993694ea67d6bb09e091600887685; _ga=GA1.2.349169911.1600887686; _gid=GA1.2.781742695.1600887686; _selluuid=1dfea200-02d7-4ad1-8922-9c25153f61c5',
                'origin': 'https://sell.flightclub.com',
                'pragma': 'no-cache',
                'referer': 'https://sell.flightclub.com/login?redirect_url=/home',
                'sec-fetch-dest': 'empty',
                'sec-fetch-mode': 'cors',
                'sec-fetch-site': 'same-origin',
                'user-agent': get_random_user_agent(),
                'content-type': 'application/json',
            },
            json={
                "user": {
                    "email": "daniel.revie1@gmail.com", 
                    "password": "Zicdrev94!",
                    'validator': token_str
                }
            }
        )
        print(login_response.status_code)
        print(login_response.content)
        if login_response.status_code == 200:
            pprint(login_response.json())
        else:
            self.simple_login()

if __name__ == '__main__':
    api = FlightClubApi()
    api.simple_login()
