import json
import collections
import requests
from requests import Session, session, get
from typing import List

from suplexedlibrary.database.postgres.postgres import get_session
from suplexedlibrary.proxies.provider import get_luminati_sync_static_residential
from suplexedlibrary.model.StadiumGoodsAccount import StadiumGoodsAccount
from suplexedlibrary.model.DataSyncAccount import DataSyncAccount



class StadiumGoodsListingResponse:
    imageUrl     : str = None
    sku          : str = None
    name         : str = None
    status       : str = None
    serial       : str = None
    size         : str = None
    intakeOn     : str = None
    listingPrice : int = None

    @staticmethod
    def get_pojo(data: dict):
        print(data)
        stadium_goods_listing = StadiumGoodsListingResponse()
        for key in data:
            print(f'key={key} value={data[key]} value_type={type(data[key])}')
            setattr(stadium_goods_listing, key, data[key])
        return stadium_goods_listing

def desrialize_listing_response(data: List[dict]) -> List[StadiumGoodsListingResponse]:
    res = []
    for obj in data:
        res.append(StadiumGoodsListingResponse.get_pojo(obj))
    
    return res

class StadiumGoodsApi:
    def __init__(
        self,
        stadium_goods_email: str,
        stadium_goods_password: str,
    ):
        self.email = stadium_goods_email
        self.password = stadium_goods_password

        print(f'Initializing SG API for {stadium_goods_email}')


    def update_listing_price(self):
        pass

    def get_active_listings(self):
        listings_reponse = get('https://suplexed-node.herokucom/stadiumgoods/active-listings')
        print(listings_reponse.json())

    
    def get_all_listings(self) -> List[StadiumGoodsListingResponse]:
        listings_reponse = requests.post(
            url='https://suplexed-node.herokucom/stadiumgoods/active-listings', 
            headers={'content-type': 'application/json'},
            json={
                'dataSyncAccountId': None,
                'stadiumgoodsEmail': self.email,
                'stadiumgoodsPassword': self.password
            }
        )

        listings_reponse = desrialize_listing_response(listings_reponse.json())
        return listings_reponse