query = '''query FetchCustomerAsks(
  $limit: Int
  $state: AsksGeneralState
  $sort: AsksSortInput
  $order: AscDescOrderInput
  $after: String
  $query: String
  $currency: CurrencyCode
  $country: String!
) {
  viewer {
    asks(
      state: $state
      first: $limit
      sort: $sort
      order: $order
      after: $after
      query: $query
      currencyCode: $currency
    ) {
      pageInfo {
        hasNextPage
        endCursor
        __typename
      }
      edges {
        node {
          id
          state
          authCenter
          expires
          amount
          orderNumber
          originalCurrency
          soldOn
          amount
          bidAskSpread
          shipment {
            shipByDate
            bulk
            __typename
          }
          productVariant {
            id
            traits {
              size
              sizeDescriptor
              __typename
            }
            market(currencyCode: $currency) {
              bidAskData(country: $country) {
                lowestAsk
                highestBid
                __typename
              }
              __typename
            }
            product {
              id
              uuid
              contentGroup
              productCategory
              urlKey
              model
              name
              restock
              styleId
              minimumBid
              media {
                thumbUrl
                imageUrl
                __typename
              }
              __typename
            }
            __typename
          }
          __typename
        }
        __typename
      }
      __typename
    }
    __typename
  }
}'''