def get_logged_in_headers(bearer_token: str, user_agent: str) -> dict:
    return {
        'authority': 'stockx.com',
        "accept": "*/*",
        "accept-language": "en-US,en;q=0.9",
        "appos": "web",
        "appversion": "0.1",
        "content-length": "207",
        "content-type": "application/json",
        'authorization': f'Bearer {bearer_token}',
        "origin": "https://stockx.com",
        "user-agent": user_agent,
        "x-requested-with": "XMLHttpRequest"
    }


def get_stockx_login_headers(user_agent: str) -> dict:
    return {
        'authority': 'stockx.com',
        'method': 'POST',
        'path': '/usernamepassword/login',
        'scheme': 'https',
        'accept': '*/*',
        'accept-encoding': 'gzip, deflate, br',
        'accept-language': 'en-US,en;q=0.9',
        'content-length': '527',
        'content-type': 'application/json',
        'origin': 'https://accounts.stockx.com',
        'referer': 'https://accounts.stockx.com/login?state=g6Fo2SAtMEZURHBhMi1ZMkhTU2dIRTlXcWxJZzhzdVpyd0JOYqN0aWTZIG11SG9jVVItR05keUZCV3hCdmJJQjZfNkg0bjRLREZOo2NpZNkgT1Z4cnQ0VkpxVHg3TElVS2Q2NjFXMER1Vk1wY0ZCeUQ&client=OVxrt4VJqTx7LIUKd661W0DuVMpcFByD&protocol=oauth2&prompt=login&audience=gateway.stockx.com&auth0Client=eyJuYW1lIjoiYXV0aDAuanMiLCJ2ZXJzaW9uIjoiOS4xMS4zIn0%3D&connection=production&redirect_uri=https%3A%2F%2Fstockx.com%2Fcallback%3Fpath%3D%2F&response_mode=query&response_type=code&scope=openid%20profile&stockx-currency=USD&stockx-default-tab=login&stockx-is-gdpr=false&stockx-language=en-us&stockx-session-id=71f44f3a-e576-4e21-b70d-f55bf56d46db&stockx-url=https%3A%2F%2Fstockx.com&stockx-user-agent=Mozilla%2F5.0%20(Macintosh%3B%20Intel%20Mac%20OS%20X%2010_15_3)%20AppleWebKit%2F537.36%20(KHTML%2C%20like%20Gecko)%20Chrome%2F81.0.4044.138%20Safari%2F537.36&ui_locales=en&lng=en',
        'sec-fetch-dest': 'empty',
        'sec-fetch-mode': 'cors',
        'sec-fetch-site': 'same-origin',
        'user-agent': user_agent,
    }


def get_authorize_login_headers(user_agent: str) -> dict:
    return {
        'authority': 'accounts.stockx.com',
        'method': 'GET',
        # 'path': '/authorize?client_id=OVxrt4VJqTx7LIUKd661W0DuVMpcFByD&response_type=code&scope=openid%20profile&stockx-session-id=522d5a64-502b-432a-9358-048dc4568fe6&stockx-default-tab=login&stockx-is-gdpr=false&stockx-language=en-us&stockx-url=https%3A%2F%2Fstockx.com&ui_locales=en&redirect_uri=https%3A%2F%2Fstockx.com%2Fcallback%3Fpath%3D%2F&response_mode=query&state=%7B%22state%22%3A%7B%22forceLogin%22%3Atrue%7D%7D&audience=gateway.stockx.com&connection=production&stockx-user-agent=Mozilla%2F5.0%20%28Macintosh%3B%20Intel%20Mac%20OS%20X%2010_14_6%29%20AppleWebKit%2F537.36%20%28KHTML%2C%20like%20Gecko%29%20Chrome%2F80.0.3987.149%20Safari%2F537.36&prompt=login&auth0Client=eyJuYW1lIjoiYXV0aDAuanMiLCJ2ZXJzaW9uIjoiOS4xMS4zIn0%3D',
        'scheme': 'https',
        'accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3;q=0.9',
        'accept-encoding': 'gzip, deflate, br',
        'accept-language': 'en-US,en;q=0.9',
        'cache-control': 'no-cache',
        'pragma': 'no-cache',
        'sec-fetch-dest': 'document',
        'sec-fetch-mode': 'navigate',
        'sec-fetch-site': 'same-site',
        'sec-fetch-user': '?1',
        'upgrade-insecure-requests': '1',
        'user-agent': user_agent
    }


light_headers = {
    "authority": "stockx.com",
    "origin": "https://stockx.com",
    "user-agent": "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36",
}
