import uuid
import flask_bcrypt
from suplexedlibrary.database.mongo.nosql import get_sneaker_db
from suplexedlibrary.database.postgres.postgres import session
from suplexedlibrary.model.DataSyncAccount import DataSyncAccount
from suplexedlibrary.model.InventoryItem import InventoryItem
from pprint import pprint

from sqlalchemy.orm import Query

db = get_sneaker_db()


def sync_users():
    print('asdasdasdasd')
    print(f'syncing {db.users.count({})} users')
    for mongo_account in db.users.find({}):
        try:
            account = DataSyncAccount(
                id=str(uuid.uuid1()),
                first_name=mongo_account['name'],
                last_name=None,
                date_of_birth=mongo_account['date_of_birth'] if 'date_of_birth' in mongo_account else None,
                user_name=mongo_account['username'] if 'username' in mongo_account else None,
                email=mongo_account['email'],
                password_no_hash=mongo_account['unhashedPassword'],
                password_hash=flask_bcrypt.generate_password_hash(mongo_account['unhashedPassword']).decode('utf-8')
            )
            session.add(account)
            session.commit()
            #print(f'sucess adding {mongo_account ["name"]}')
        except Exception as e:
            print(f'failed adding {mongo_account["name"]}')
            session.rollback()
            pprint(e)


def sync_inventory():
    print('syncing inventory')
    return 
    for inventory_item in db.shoeInventory.find({}):
        email = inventory_item['email']
        data_sync_account = session.query(DataSyncAccount).filter(
            DataSyncAccount.email == email).one()

        if data_sync_account == None:
            continue

        new_inventory_item = InventoryItem(
            id=str(uuid.uuid1()),
            account_id=data_sync_account.id,
            shoeName=inventory_item['shoeName'],
            shoeSize=inventory_item['shoeSize'],
            shoeSku=inventory_item['shoeSku'],
            purchasePrice=inventory_item['purchasePrice'],
            purchaseFees=inventory_item['purchaseFees'],
            purchaseDiscount=inventory_item['purchaseDiscount'],
            purchaseShipping=inventory_item['purchaseShipping'],
            purchaseDate=inventory_item['purchaseDate'],
            email=inventory_item['email'],
            purchaseExchange=inventory_item['purchaseExchange'],
            soldDate=inventory_item['soldDate'],
            soldPrice=inventory_item['soldPrice'],
            soldFee=inventory_item['soldFee'],
            soldDiscount=inventory_item['soldDiscount'],
            soldShipping=inventory_item['soldShipping'],
            soldExchange=inventory_item['soldExchange'],
            shoeReleaseDate=inventory_item['shoeReleaseDate'],
            shoeGender=inventory_item['shoeGender'] if 'shoeGender' in inventory_item else None,
            purchaseAccount=inventory_item['purchaseAccount'] if 'purchaseAccount' in inventory_item else None,
            orderNumber=inventory_item['orderNumber'] if 'orderNumber' in inventory_item else None,
            status=inventory_item['status'] if 'status' in inventory_item else None,
            orderStatus=inventory_item['orderStatus'] if 'orderStatus' in inventory_item else None,
        )

        session.add(new_inventory_item)
        session.commit()
