import os
from sqlalchemy import create_engine
from sqlalchemy.orm import sessionmaker, Session as TSession
from sqlalchemy.orm import scoped_session
from sqlalchemy import Table, Column, String, MetaData
import uuid

from suplexedlibrary.database.postgres.base import base
from suplexedlibrary.database.postgres import init_tables
from suplexedlibrary.model.DataSyncAccount import DataSyncAccount
from suplexedlibrary.model.AskGoat import AskGoat
from suplexedlibrary.model.AskStockX import AskStockX
from suplexedlibrary.model.ResellPricing import ResellPricing
from suplexedlibrary.model.GoatAccount import GoatAccount
from suplexedlibrary.model.InventoryItem import InventoryItem
from suplexedlibrary.model.PricingStrategy import PricingStrategy
from suplexedlibrary.model.SyncUserValueChain import SyncUserValueChain


Session = None
meta = None
engine = None

def create_test_db():
    global Session
    global meta
    global engine

    db_string = 'postgresql://postgres:B7AqoetvVtJ64OLWqjiGxFxTrjkVT59k@suplexed-prod-postgres-standalone.c3uoix5oahbz.us-east-2.rds.amazonaws.com:5432/assist?sslmode=require'
    engine = create_engine(db_string)
    Session = sessionmaker(engine)
    meta = MetaData(engine)
    base.metadata.create_all(engine)

def create_user_event_table():
    init_tables.init_user_event_table(meta, engine)

def create_data_sync_account_table():
    init_tables.init_data_sync_account_table(meta, engine)

def get_session() -> TSession:
    return Session()

def db_close_connections():
    get_session().close_all()

def get_new_session() -> TSession:
    print(Session)
    return Session()


