

class NoLoginExistsException(Exception):
    """ Raised when no login for an account exists """

class ActiveMfaLoginException(Exception):
    """ Raised when an account has an active MFA session """

class UpdatePriceException(Exception):
    """ Raised when updating the price of a listing fails """

class NoListingFoundForUpdateException(Exception):
    """ Raised when no listing is found to update on a marketplace """

class CreateListingException(Exception):
    """ Raised when creating a listing fails """

class DeleteListingFailedException(Exception):
    """ Raised when deleting a listing fails """

class FailedFetchingListings(Exception):
    """ Raised when failure occurrs during a listing fetch """

class ListingsChangedWhileFetchingException(Exception):
    """ Raised when the listings count changes while we are fetching them """

class Scraping403Exception(Exception):
    """ Raised when scraping the stockx api fails"""

class Exception404(Exception):
    """ Raised when a 404 is thrown on an api request """

class GoatException404(Exception404):
    """ Raised when a 404 is thrown on an api request """

class Exception500(Exception):
    """ Raised when a 500 is thrown """

class GoatException500(Exception500):
    """ Raised when a 404 is thrown on an api request """

class Exception400(Exception):
    """ Raised when a 500 is thrown """

class Exception401(Exception):
    """ Raised when a 401 is thrown """

class GoatException400(Exception400):
    """ Raised when a 404 is thrown on an api request """

class DeleteListingNotFoundException(Exception404):
    """ Raised when a listing could not be found for deletion """

class ProductUnavailableForBiddingException(Exception):
    """ Thrown when a product it not available for bidding """

class DeleteFailedListingAlreadySoldExceiption(Exception):
    """ Thrown when a listing is deleted that has already been sold """