from uuid import uuid4
from datetime import datetime
from suplexedlibrary.model.UserEvent import UserEvent
from suplexedlibrary.constants.UserEventType import UserEventType
from suplexedlibrary.database.postgres.postgres import get_new_session

def create_synced_sale_user_event(
    account_id: str, 
    inventory_item_id: str,
    sale_order_id: str,
    shoe_name: str,
    shoe_size: str,
    sold_formatted_amount: str,
    image_url: str,
    sold_marketplace: str,
    delisted_marketplace: str
) -> UserEvent:
    user_event = UserEvent(
        id                                 = str(uuid4()),
        account_id                         = account_id,
        inventory_id                       = inventory_item_id,       
        sale_order_id                      = sale_order_id,
        purchase_order_id                  = None,
        event_type                         = UserEventType.SALE,
        event_title                        = f'Synced Sale recored for {shoe_name} size {shoe_size} on {sold_marketplace}',
        event_text                         = f'Congratulations, you have a new sale! Your item sold for ${sold_formatted_amount:,}.00 on {sold_marketplace} and successfully delisted ask on {delisted_marketplace}.',
        event_link                         = None,
        event_time                         = datetime.now(),
        event_image                        = image_url
    )
    return user_event


def create_sale_user_event(
    account_id: str, 
    inventory_item_id: str,
    sale_order_id: str,
    shoe_name: str,
    shoe_size: str,
    sold_formatted_amount: str,
    image_url: str,
    sold_marketplace: str,
) -> UserEvent:
    user_event = UserEvent(
        id                                 = str(uuid4()),
        account_id                         = account_id,
        inventory_id                       = inventory_item_id,       
        sale_order_id                      = sale_order_id,
        purchase_order_id                  = None,
        event_type                         = UserEventType.SALE,
        event_title                        = f'Sale recored for {shoe_name} size {shoe_size} on {sold_marketplace}',
        event_text                         = f'Congratulations, you have a new sale! Your item sold for ${sold_formatted_amount:,}.00 on {sold_marketplace}.',
        event_link                         = None,
        event_time                         = datetime.now(),
        event_image                        = image_url
    )
    return user_event