import json
import traceback
from kafka import KafkaProducer


class KafkaSuplexedClient():
    NEW_SALE_EVENT_TOPIC = 'new_product_sale'
    UPDATE_SALE_EVENT_TOPIC = 'update_product_sale'

    PRICING_CHANGE_STOXKX_TOPIC = 'pricing_change_stockx'
    PRICING_CHANGE_GOAT_TOPIC = 'pricing_change_goat'
    PRICING_CHANGE_FLIGHTCLUB_TOPIC = 'pricing_change_flightclub'
    PRICING_CHANGE_STADIUMGOODS_TOPIC = 'pricing_change_stadiumgoods'

    
    PRICING_CHANGE_CONSUMER_GROUP = 'pricing-change-group'

    def __init__(self) -> None:
        self.brokers = [
            'kafka-0.kafka.kafka.svc.cluster.local:9092',
            'kafka-1.kafka.kafka.svc.cluster.local:9092',
            'kafka-2.kafka.kafka.svc.cluster.local:9092'
        ]
        self.producer = KafkaProducer(
            security_protocol='PLAINTEXT',
            bootstrap_servers=self.brokers
        )


    def send_message(self, topic: str, message: dict):
        try:
            self.producer.send(topic, json.dumps(message).encode('utf-8'))
        except Exception as e:
            traceback.print_exc()
