import argparse
from requests import session
from pprint import pprint
from uuid import uuid1

from suplexedlibrary.database.postgres.postgres import get_session
from suplexedlibrary.proxies import provider
from suplexedlibrary.model.GoatAccount import GoatAccount
from suplexedlibrary.model.DataSyncAccount import DataSyncAccount
from suplexedlibrary.model.GoatSellerScore import GoatSellerScore
from suplexedlibrary.model.StockxSellerScore import StockxSellerScore
from suplexedlibrary.model.StockxAccount import StockxAccount
from suplexedlibrary.model.GoatAccount import GoatAccount
from suplexedlibrary.api.GoatApi import GoatApi
from suplexedlibrary.api.StockxApi import StockXApi
from suplexedlibrary.proxies import provider



    

def generate_goat_seller_score(account: GoatAccount):
    pass


def generate_seller_scores(account_level: str):
    for account in get_session().query(DataSyncAccount).filter(DataSyncAccount.email == 'daniel.revie1@gmail.com').all():
        stockx_api = StockXApi(account.stockxAccount[0])
        goat_api =  GoatApi(provider.get_zone_one_static_session_daniel_revie_gmail(), account.goatAccount[0])

        (stockx_seller_fee, stockx_seller_level) = stockx_api.get_seller_fees()

        if account.stockxSellerScore:
            account.stockxSellerScore.level = stockx_seller_level
            account.stockxSellerScore.transaction_fee_streetwear = stockx_seller_fee
            account.stockxSellerScore.transaction_fee_collectibles = stockx_seller_fee
        else:
            stockx_seller_score = StockxSellerScore(
                id                           = str(uuid1()),
                account_id                   = account.id,
                level                        = stockx_seller_level,
                transaction_fee_streetwear   = stockx_seller_fee,
                transaction_fee_collectibles = stockx_seller_fee,
            )
            get_session().add(stockx_seller_score)


        (seller_transaction_fee, seller_flat_fee, seller_score) = goat_api.get_seller_info()
        if account.goatSellerScore:
            account.goatSellerScore.seller_transaction_fee = seller_transaction_fee
            account.goatSellerScore.seller_flat_fee = seller_flat_fee
            account.goatSellerScore.seller_score = seller_score

        else:
            goat_seller_score = GoatSellerScore(
                id=str(uuid1()),
                account_id=account.id,
                seller_transaction_fee=seller_transaction_fee,
                seller_flat_fee=seller_flat_fee,
                seller_score=seller_score
            )
            get_session().add(goat_seller_score)


        get_session().commit()


if __name__ == '__main__':
    parser = argparse.ArgumentParser(description='inventory processor arguments!')
    parser.add_argument("--accountLevel", default='beta')
    args = parser.parse_args()
    generate_seller_scores(account_level=args.accountLevel)