from suplexedlibrary.database.postgres.base import base
from .AliasAccountLink import AliasAccountLink

from sqlalchemy import Column, String, ForeignKey, PickleType, Boolean, DateTime, Integer
from sqlalchemy.orm import relationship

class AliasAccount(base):
    __tablename__ = 'aliasAccount'

    id                  = Column(String, primary_key=True)
    account_id          = Column(String, ForeignKey('dataSyncAccount.id'))
    email               = Column(String)
    password            = Column(String)
    onboarded_orders    = Column(Boolean)
    onboarded_listings  = Column(Boolean)
    is_mfa              = Column(Boolean)
    invalid_credentials = Column(Boolean)
    mfa_triggered_at    = Column(DateTime)

    access_token        = Column(String)
    access_token_expiry = Column(Integer)
    refresh_token       = Column(String)
    token_type          = Column(String)

    seller_score        = Column(Integer)


    linked_accounts     = relationship(AliasAccountLink)