from suplexedlibrary.database.postgres.base import base

from sqlalchemy import Column, String, ForeignKey, Integer, Float, DateTime
from sqlalchemy.orm import relationship

class AskFlightClub(base):
    __tablename__ = 'askFlightClub'
    id                  = Column(String, primary_key=True)
    inventory_item_id   = Column(String, ForeignKey('inventoryItem.id')) 
    account_id          = Column(String, ForeignKey('dataSyncAccount.id'))
    ask_amount          = Column(Integer)
    real_ask_amount     = Column(Integer)
    start_price         = Column(Integer)
    exchange            = Column(String)
    exchange_ask_id     = Column(String)
    style_id            = Column(String)
    size                = Column(Float)
    created_at          = Column(DateTime)
    status              = Column(String)
    last_priced_time    = Column(DateTime)
    
    inventoryItem       = relationship('InventoryItem', back_populates='askFlightClub')