from sqlalchemy.sql.operators import is_natural_self_precedent
from suplexedlibrary.database.postgres.base import base

from sqlalchemy import Column, String, ForeignKey, Integer, Float, DateTime, Boolean, BigInteger
from sqlalchemy.orm import relationship

class AskGoat(base):
    __tablename__ = 'askGoat'
    id                        = Column(String, primary_key=True)
    inventory_item_id         = Column(String, ForeignKey('inventoryItem.id')) 
    account_id                = Column(String, ForeignKey('dataSyncAccount.id'))
    ask_amount                = Column(Integer)
    real_ask_amount           = Column(Integer)
    start_price               = Column(Integer)
    exchange                  = Column(String)
    exchange_ask_id           = Column(BigInteger)
    style_id                  = Column(String)
    size                      = Column(String)
    created_at                = Column(DateTime)
    status                    = Column(String)
    is_consigned              = Column(Boolean)
    is_used                   = Column(Boolean)
    
    inventoryItem             = relationship('InventoryItem', back_populates='askGoat')