from sqlalchemy.sql.sqltypes import Boolean
from suplexedlibrary.database.postgres.base import base
from sqlalchemy import Column, String, ForeignKey, Integer, Float, DateTime
from sqlalchemy.orm import relationship

class AskStockX(base):
    __tablename__ = 'askStockX'
    id                = Column(String, primary_key=True)
    inventory_item_id = Column(String, ForeignKey('inventoryItem.id')) 
    account_id        = Column(String, ForeignKey('dataSyncAccount.id'))
    stockx_account_id = Column(String, ForeignKey('stockxAccount.id'))
    ask_amount        = Column(Integer)
    real_ask_amount   = Column(Integer)
    start_price       = Column(Integer)
    exchange          = Column(String)
    exchange_ask_id   = Column(String)
    expiry_date       = Column(DateTime)
    is_expired        = Column(Boolean)
    style_id          = Column(String)
    size              = Column(String)
    stx_sku_uuid      = Column(String)
    created_at        = Column(DateTime)
    status            = Column(String)

    inventoryItem     = relationship('InventoryItem', back_populates='askStockX')