from suplexedlibrary.database.postgres.base import base
from sqlalchemy import Column, String, DateTime, Integer
import datetime


class BlacklistToken(base):
    """
    Token Model for storing JWT tokens
    """
    __tablename__ = 'blacklist_tokens'

    id             = Column(Integer, primary_key=True, autoincrement=True)
    token          = Column(String(500), unique=True, nullable=False)
    blacklisted_on = Column(DateTime, nullable=False)

    def __init__(self, token):
        self.token = token
        self.blacklisted_on = datetime.datetime.now()

    def __repr__(self):
        return '<id: token: {}'.format(self.token)

    @staticmethod
    def check_blacklist(auth_token, db_session):
        from suplexedlibrary.database.postgres.postgres import get_session

        # check whether auth token has been blacklisted
        res = db_session.query(BlacklistToken).filter_by(token=str(auth_token)).first()

        if res:
            return True
        else:
            return False