from sqlalchemy import Column, String, ForeignKey, PickleType, Boolean, DateTime
from suplexedlibrary.database.postgres.base import base
from sqlalchemy.orm import relationship

class FlightClubAccount(base):
    __tablename__ = 'flightClubAccount'

    id                   = Column(String, primary_key=True)
    account_id           = Column(String, ForeignKey('dataSyncAccount.id'))
    email                = Column(String)
    password             = Column(String)
    onboarded_orders     = Column(Boolean)
    onboarded_listings   = Column(Boolean)
    is_mfa               = Column(Boolean)
    invalid_credentials  = Column(Boolean)
    mfa_triggered_at     = Column(DateTime)
    is_account_activated = Column(Boolean)

    created_at             = Column(DateTime)
    updated_at             = Column(DateTime) 