from sqlalchemy import Column, String, ForeignKey, Boolean, DateTime
from suplexedlibrary.database.postgres.base import base
from sqlalchemy.orm import relationship

class GoatAccount(base):
    __tablename__ = 'goatAccount'
    
    id                   = Column(String, primary_key=True)
    account_id           = Column(String, ForeignKey('dataSyncAccount.id'))
    email                = Column(String)
    password             = Column(String)
    x_px_authorization   = Column(String)
    authorization        = Column(String)
    x_emb_st             = Column(String)
    cookie               = Column(String)
    x_emb_id             = Column(String)
    user_agent           = Column(String)
    x_px_original_token  = Column(String)
    user_id              = Column(String)
    onboarded_orders     = Column(Boolean)
    onboarded_listings   = Column(Boolean)
    dedicated_proxy      = Column(String)
    invalid_credentials  = Column(Boolean)
    is_account_activated = Column(Boolean)

    created_at             = Column(DateTime)
    updated_at             = Column(DateTime)     