from suplexedlibrary.database.postgres.base import base

from sqlalchemy import Column, String, ForeignKey, Date, Integer, Boolean, ARRAY
from sqlalchemy.orm import relationship

class PricingStrategy(base):
    __tablename__   = 'pricingStrategy'
    id              = Column(String, primary_key=True)
    account_id      = Column(String, ForeignKey('dataSyncAccount.id'))
    inventory_id    = Column(String, ForeignKey('inventoryItem.id'))
    expiration_date = Column(Date)
    strategy_type   = Column(String)
    maximize_profit = Column(Boolean)
    mute_goat       = Column(Boolean)
    mute_stockx     = Column(Boolean)

    inventoryItem   = relationship('InventoryItem', back_populates='pricingStrategy')