from suplexedlibrary.database.postgres.base import base

from sqlalchemy import Column, String, ForeignKey, Date, Integer, Boolean, DateTime, Float
from sqlalchemy.orm import relationship
from sqlalchemy.sql import func
from datetime import datetime

class PurchaseOrder(base):
    __tablename__             = 'purchaseOrder'
    id                        = Column(String, primary_key=True)
    account_id                = Column(String, ForeignKey('dataSyncAccount.id'))
    inventory_id              = Column(String, ForeignKey('inventoryItem.id'))
    exchange_ask_id           = Column(String)
    marketplace               = Column(String)
    shoe_sku                  = Column(String)
    shoe_name                 = Column(String)
    shoe_size                 = Column(String)
    purchase_date             = Column(Date)
    purchase_amount           = Column(Float)
    purchase_fee              = Column(Float)
    purchase_shipping         = Column(Float)
    purchase_discount         = Column(Float)
    purchase_total            = Column(Float)
    purchase_tax              = Column(Float)
    image_url                 = Column(String)
    order_status              = Column(String)
    tracking_url              = Column(String)
    tracking_delivery_date    = Column(String)
    tracking_number           = Column(String)
    tracking_status           = Column(String)
    status_code               = Column(String)
    order_number              = Column(String)
    purchase_method           = Column(String)
    authentication_fee        = Column(String)
    product_type              = Column(String)


    inventoryItem   = relationship('InventoryItem', back_populates='purchaseOrder')