from suplexedlibrary.database.postgres.base import base

from sqlalchemy import Column, String, ForeignKey, Date, Integer, Float, Boolean, ARRAY
from sqlalchemy.orm import relationship

class ReportCardType:
    GLOBAL       = 'GLOBAL'
    STOCKX       = 'STOCKX'
    GOAT         = 'GOAT'
    STADIUMGOODS = 'STADIUMGOODS'
    FLIGHTCLUB   = 'FLIGHTCLUB'


class ReportCardResult(base):
    __tablename__                  = 'reportCardResult'
    id                             = Column(String, primary_key=True)
    account_id                     = Column(String, ForeignKey('dataSyncAccount.id'))
    created_at                     = Column(Date)
    report_card_type               = Column(String)
    profitable_sales_missed_count  = Column(Integer, default=0)
    profit_missed_dollars          = Column(Float, default=0)
    total_sales                    = Column(Integer, default=0)
    revenue_dollars                = Column(Float, default=0)
    total_purchases                = Column(Integer, default=0)
    purchase_cost_dollars          = Column(Float, default=0)
    active_listings                = Column(Integer, default=0)
    active_listings_value_dollars  = Column(Float, default=0)
