from suplexedlibrary.database.postgres.base import base

from sqlalchemy import Column, String, ForeignKey, Date, Integer, Boolean, DateTime, Float
from sqlalchemy.orm import relationship
from sqlalchemy.sql import func
from datetime import datetime

class ResellPricing(base):
    __tablename__                  = 'resellPricing'
    id                             = Column(String, primary_key=True)
    inventory_id                   = Column(String, ForeignKey('inventoryItem.id'))
    inventoryItem                  = relationship('InventoryItem', back_populates='resellPricing')
    goat_ask                       = Column(Integer)
    goat_offer                     = Column(Integer)
    stockx_ask                     = Column(Integer)
    stockx_offer                   = Column(Integer)
    stadium_goods_ask              = Column(Integer)
    flight_club_ask                = Column(Integer)
    stadium_goods_web_ask          = Column(Integer)

    stockx_ask_profit_margin       = Column(Float)
    stockx_profit_margin           = Column(Float)
    goat_ask_profit_margin         = Column(Float)
    goat_profit_margin             = Column(Float)

    is_goat_ask_calculated         = Column(Boolean)
    is_stockx_ask_calculated       = Column(Boolean)
    is_stadiumgoods_ask_calculated = Column(Boolean)

    time_created                   = Column(DateTime(timezone=True), server_default=func.now())
    time_updated                   = Column(DateTime(timezone=True), onupdate=func.now())
    
