from suplexedlibrary.database.postgres.base import base

from sqlalchemy import Column, String, ForeignKey, Date, Integer, Boolean, DateTime, Float
from sqlalchemy.orm import relationship
from sqlalchemy.sql import func
from datetime import datetime

class SaleOrder(base):
    __tablename__         = 'saleOrder'
    id                          = Column(String, primary_key=True)
    account_id                  = Column(String, ForeignKey('dataSyncAccount.id'))
    inventory_id                = Column(String, ForeignKey('inventoryItem.id'))
    exchange_ask_id             = Column(String)
    marketplace                 = Column(String)
    shoe_sku                    = Column(String)
    shoe_name                   = Column(String)
    shoe_size                   = Column(String)
    sold_date                   = Column(Date)
    sold_amount                 = Column(Float)
    sold_payout                 = Column(Float)
    sold_transaction_fee        = Column(Float)
    sold_payment_processing_fee = Column(Float)
    sold_shipping               = Column(Float)
    sold_discount               = Column(Float)
    sold_tax                    = Column(Float)
    image_url                   = Column(String)
    order_status                = Column(String)
    tracking_url                = Column(String)
    tracking_delivery_date      = Column(String)
    tracking_number             = Column(String)
    tracking_status             = Column(String)
    status_code                 = Column(String)
    order_number                = Column(String)
    payout_destination          = Column(String)
    listing_creation_date       = Column(DateTime)
    shipping_label_url          = Column(String)
    is_sale_confirmed           = Column(Boolean)

    inventoryItem   = relationship('InventoryItem', back_populates='saleOrder')