from sqlalchemy import Column, String, ForeignKey, Boolean, DateTime
from suplexedlibrary.database.postgres.base import base
from sqlalchemy.orm import relationship

class StockxAccount(base):
    __tablename__          = 'stockxAccount'
    id                     = Column(String, primary_key=True)
    account_id             = Column(String, ForeignKey('dataSyncAccount.id'))
    email                  = Column(String)
    password               = Column(String)
    customer_id            = Column(String)
    onboarded_orders       = Column(Boolean)
    onboarded_listings     = Column(Boolean)
    dedicated_proxy        = Column(String)
    is_mfa                 = Column(Boolean)
    mfa_triggered_at       = Column(DateTime)
    state_token            = Column(String)
    invalid_credentials    = Column(Boolean)
    is_account_activated   = Column(Boolean)
    haspasswordbeenchanged = Column(Boolean)

    created_at             = Column(DateTime)
    updated_at             = Column(DateTime) 