from sqlalchemy import Column, String, DateTime, Integer, ForeignKey
from suplexedlibrary.database.postgres.base import base


class UserEvent(base):
    __tablename__ = 'userEvent'
    id                                 = Column(String, primary_key=True)
    account_id                         = Column(String, ForeignKey('dataSyncAccount.id'))
    inventory_id                       = Column(String, ForeignKey('inventoryItem.id'), nullable=True)
    purchase_order_id                  = Column(String, ForeignKey('purchaseOrder.id'), nullable=True)
    sale_order_id                      = Column(String, ForeignKey('saleOrder.id'), nullable=True)
    event_type                         = Column(String)
    event_title                        = Column(String)
    event_text                         = Column(String)
    event_link                         = Column(String)
    event_time                         = Column(String)
    event_image                        = Column(String)

