from pprint import pprint
import random
from suplexedlibrary.model.GoatAccount import GoatAccount
import time
from typing import List

from suplexedlibrary.model.AskGoat import AskGoat
from suplexedlibrary.database.postgres.postgres import get_session
from suplexedlibrary.model.StockxAccount import StockxAccount
from suplexedlibrary.model.InventoryItem import InventoryItem
from suplexedlibrary.api.GoatApi import GoatApi
from suplexedlibrary.exceptions import DeleteListingNotFoundException, DeleteListingFailedException

db_session = get_session()


def process_goat_deletes(
    dont_delete_set: set,
    delete_list: List[dict],
    goat_api: GoatApi
):
    for item in delete_list:
        exchange_ask_id = item['id']
        if exchange_ask_id in dont_delete_set:
            continue

        try:
            goat_api.delete_own(exchange_ask_id)
            db_session.query(AskGoat).filter(
                AskGoat.exchange_ask_id == exchange_ask_id).delete()
        except Exception as e:
            print(e)


def delete_all_goat():
    account = db_session.query(GoatAccount).filter(
        GoatAccount.email == 'daniel.revie1@gmail.com').first()
    api = GoatApi(account, skip_login=False)

    listings = api.get_listings()
    
    print(f'deleting {len(listings)} stockx inventory items')
    input('...enter to continue')

    process_goat_deletes(set(), listings, api)

if __name__ == '__main__':
    delete_all_goat()
