from pprint import pprint
from suplexedlibrary.database.postgres.postgres import get_session
from suplexedlibrary.model.DataSyncAccount import DataSyncAccount
from suplexedlibrary.api.main.service.stripe_service import create_stripe_customer, get_stripe_customer



def main():
    user_cursor = get_session().query(DataSyncAccount).all()

    for user in user_cursor:
        try:
            customer = get_stripe_customer(user.stripe_id)
            if customer['livemode'] == True:
                continue

            try:
                stripe_id = create_stripe_customer(user.email, {'syncAccountId': user.id})
            except Exception as e:
                print(e)
                continue
            print(f'\tupdating {user.email} from {user.stripe_id} to {stripe_id}')
            user.stripe_id = stripe_id
            get_session().commit()
        except Exception as e:
            print(e)
            try:
                stripe_id = create_stripe_customer(user.email, {'syncAccountId': user.id})
            except Exception as e:
                print(e)
                continue
            print(f'\tupdating {user.email} from {user.stripe_id} to {stripe_id}')
            user.stripe_id = stripe_id
            get_session().commit()

if __name__ == '__main__':
    main()