from suplexedlibrary.database.postgres.postgres import get_session
from suplexedlibrary.model.DataSyncAccount import DataSyncAccount
from suplexedlibrary.model.InventoryItem import InventoryItem
from datetime import datetime


def generate_timestamps():
    for inventory_item in get_session().query(InventoryItem).all():

        if inventory_item.saleOrder and inventory_item.saleOrder.sold_date:
            print(f'updating {inventory_item.id} by sale')
            inventory_item.last_updated_time = inventory_item.saleOrder.sold_date
            get_session().commit()

        elif inventory_item.purchaseOrder and inventory_item.purchaseOrder.purchase_date:
            print(f'updating {inventory_item.id} by purchase')
            inventory_item.last_updated_time = inventory_item.purchaseOrder.purchase_date
            get_session().commit()
        
        else:
            print('defaulting')
            inventory_item.last_updated_time = datetime.now()
            get_session().commit()

if __name__ == '__main__':
    generate_timestamps()