from datetime import datetime
from typing import Dict, List, Optional, List, Generic, TypeVar
from pydantic import BaseModel
from pydantic.generics import GenericModel

T = TypeVar('T')



class SuplexedPricingResponse_Pricing_Summary_Details(BaseModel):
    price: int
    size: str

class SuplexedPricingResponse_Pricing(GenericModel, Generic[T]):
    lowestPrice: Optional[T] = None
    highestOffer: Optional[T] = None


class SuplexedPricingResponse_Listings_Summary(GenericModel, Generic[T]):
    all: Optional[SuplexedPricingResponse_Pricing[T]]
    stockx: Optional[SuplexedPricingResponse_Pricing[T]] = None
    goat: Optional[SuplexedPricingResponse_Pricing[T]] = None
    flightclub: Optional[SuplexedPricingResponse_Pricing[T]] = None
    stadiumgoods: Optional[SuplexedPricingResponse_Pricing[T]] = None



class SuplexedPricingResponse_Listings(BaseModel):
    summary: SuplexedPricingResponse_Listings_Summary[SuplexedPricingResponse_Pricing_Summary_Details]
    sizes: Dict[str, SuplexedPricingResponse_Listings_Summary[int]]

class SuplexedPricingResponse_Meta_Images(BaseModel):
    large: str
    thumb: str


class SuplexedPricingResponse_Meta(BaseModel):
    styleId: str
    title: str
    colorway: Optional[str]
    releaseDate: Optional[str]
    retailPrice: Optional[int] = None
    images: SuplexedPricingResponse_Meta_Images
    categories: List[str]
    sizeLabel: Optional[str] = ''

class SuplexedPricingResponse_Marketplaces_Details_StockX(BaseModel):
    url: str
    productId: str

class SuplexedPricingResponse_Marketplaces_Details(BaseModel):
    url: str


class SuplexedPricingResponse_Marketplaces(BaseModel):
    stockx: SuplexedPricingResponse_Marketplaces_Details_StockX = None
    goat: SuplexedPricingResponse_Marketplaces_Details = None
    stadiumgoods: SuplexedPricingResponse_Marketplaces_Details = None
    flightclub: SuplexedPricingResponse_Marketplaces_Details = None


class SuplexedPricingResponse(BaseModel):
    meta: SuplexedPricingResponse_Meta
    listings: SuplexedPricingResponse_Listings
    marketplaces: SuplexedPricingResponse_Marketplaces
