from typing import Dict, List, Optional, List, Generic, TypeVar
from pydantic import BaseModel
from pydantic.generics import GenericModel

class GoatAlgoliaResponse_Hit(BaseModel):
   activity: Optional[str]
   box_condition: str
   brand_name: str
   breadcrumb_path_url: Optional[str]
   category: List[str]
   collection_slugs: List[str]
   color: str
   designer: Optional[str]
   details: str
   direct_shipping: bool
   gender: List[str]
   grid_display_picture_url: str
   grid_glow_picture_url: str
   grid_picture_url: str
   has_picture: bool
   has_stock: bool
   has_under_retail_availability: bool
   id: int
   instant_ship_lowest_price_cents: Optional[int]
   instant_ship_lowest_price_cents_aud: Optional[int]
   instant_ship_lowest_price_cents_cad: Optional[int]
   instant_ship_lowest_price_cents_cny: Optional[int]
   instant_ship_lowest_price_cents_eur: Optional[int]
   instant_ship_lowest_price_cents_gbp: Optional[int]
   instant_ship_lowest_price_cents_hkd: Optional[int]
   instant_ship_lowest_price_cents_jpy: Optional[int]
   instant_ship_lowest_price_cents_krw: Optional[int]
   instant_ship_lowest_price_cents_sgd: Optional[int]
   instant_ship_lowest_price_cents_twd: Optional[int]
   instant_ship_lowest_price_cents_usd: Optional[int]
   is_fashion_product: bool
   is_raffle_product: bool
   is_under_retail: bool
   is_wantable: bool
   keywords: List[str]
   lowest_price_cents: int
   lowest_price_cents_aud: int
   lowest_price_cents_cad: int
   lowest_price_cents_cny: int
   lowest_price_cents_eur: int
   lowest_price_cents_gbp: int
   lowest_price_cents_hkd: int
   lowest_price_cents_jpy: int
   lowest_price_cents_krw: int
   lowest_price_cents_sgd: int
   lowest_price_cents_twd: int
   lowest_price_cents_usd: int
   main_display_picture_url: str
   main_glow_picture_url: str
   main_picture_url: str
   midsole: Optional[str]
   name: str
   nickname: str
   number_of_related_listings: str
   objectID: str
   original_picture_url: str
   presentation_size: str
   product_category: str
   product_taxonomy: Dict
   product_template_id: int
   product_type: str
   release_date: str
   release_date_name: Optional[str]
   release_month: int
   release_year: int
   resellable: bool
   retail_price_cents: int
   retail_price_cents_aud: int
   retail_price_cents_cad: int
   retail_price_cents_cny: int
   retail_price_cents_eur: int
   retail_price_cents_gbp: int
   retail_price_cents_hkd: int
   retail_price_cents_jpy: int
   retail_price_cents_krw: int
   retail_price_cents_sgd: int
   retail_price_cents_twd: int
   retail_price_cents_usd: int
   search_sku: str
   season: Optional[str]
   season_year: Optional[str]
   shoe_condition: str
   silhouette: str
   single_gender: str
   size: float
   size_brand: str
   size_range: List[float]
   size_eu_infant: Optional[int or str or None]
   size_eu_men: Optional[int or str or None]
   size_eu_women: Optional[int or str or None]
   size_eu_youth: Optional[int or str or None]
   size_fr_infant: Optional[int or str or None]
   size_fr_men: Optional[int or str or None]
   size_fr_women: Optional[int or str or None]
   size_fr_youth: Optional[int or str or None]
   size_it_infant: Optional[int or str or None]
   size_it_men: Optional[int or str or None]
   size_it_women: Optional[int or str or None]
   size_it_youth: Optional[int or str or None]
   size_jp_infant: Optional[int or str or None]
   size_jp_men: Optional[int or str or None]
   size_jp_women: Optional[int or str or None]
   size_jp_youth: Optional[int or str or None]
   size_uk_infant: Optional[int or str or None]
   size_uk_men: Optional[int or str or None]
   size_uk_women: Optional[int or str or None]
   size_uk_youth: Optional[int or str or None]
   size_us_infant: Optional[int or str or None]
   size_us_men: Optional[int or str or None]
   size_us_women: Optional[int or str or None]
   size_us_youth: Optional[int or str or None]
   sku: str
   slug: str
   special_display_price_cents: int
   special_type: str
   status: str
   story_html: str
   upper_material: Optional[str]

class GoatAlgoliaResponse(BaseModel):
    exhaustiveNbHits: bool
    hitsPerPage: int
    nbHits: int
    nbPages: int
    page: int
    params: str
    processingTimeMS: int
    query: str
    hits: List[GoatAlgoliaResponse_Hit]