from typing import Dict, List, Optional, List, Generic, TypeVar
from pydantic import BaseModel
from pydantic.generics import GenericModel

class StockxAlgoliaResponse_Hit_Traits(BaseModel):
    name: str
    value: str
    filterable: bool
    visible: bool
    highlight: bool

class StockxAlgoliaResponse_Hit_Media(BaseModel):
    imageUrl: str
    smallImageUrl: str
    thumbUrl: str
    hidden: bool

class StockxAlgoliaResponse_Hit(BaseModel):
   id: str
   uuid: str
   name: str
   brand: str
   thumbnail_url: str
   media: StockxAlgoliaResponse_Hit_Media
   url: str
   release_date: str
   categories: List[str]
   product_category: str
   ticker_symbol: str
   style_id: str
   make: str
   model: str
   short_description: str
   gender: str
   colorway: str
   price: int
   description: str
   highest_bid: int
   total_dollars: int
   lowest_ask: int
   last_sale: int
   sales_last_72: int
   deadstock_sold: int
   quality_bid: int
   active: int
   new_release: int
   featured: int
   lock_selling: bool
   selling_countries: List[str]
   buying_countries: List[str]
   Traits: List[StockxAlgoliaResponse_Hit_Traits]

   searchable_traits: Dict[str, str or bool or int]
   objectID: str
    


class StockxAlgoliaResponse(BaseModel):
    exhaustiveNbHits: bool
    hitsPerPage: int
    nbHits: int
    nbPages: int
    page: int
    params: str
    processingTimeMS: int
    query: str
    hits: List[StockxAlgoliaResponse_Hit]