from datetime import datetime
from typing import Dict, Optional, List, Generic, TypeVar
from pydantic import BaseModel
from pydantic.generics import GenericModel

from suplexedlibrary.types.stockx.common.ProductVariant import ProductVariant
from suplexedlibrary.types.stockx.common.Shipment import Shipment


class ListingResponseGQL_Data_Viewer_Asks_Edge_Node(BaseModel):
    amount: int
    authCenter: str
    bidAskSpread: int
    expires: str
    id: str
    orderNumber: str
    originalCurrency: str
    productVariant: ProductVariant
    shipment: Shipment
    soldOn: str
    state: int

class ListingResponseGQL_Data_Viewer_Asks_Edge(BaseModel):
    node: ListingResponseGQL_Data_Viewer_Asks_Edge_Node
    
class ListingResponseGQL_Data_Viewer_Asks(BaseModel):
    edges: List[ListingResponseGQL_Data_Viewer_Asks_Edge]

class ListingResponseGQL_Data_Viewer(BaseModel):
    asks:ListingResponseGQL_Data_Viewer_Asks

class ListingResponseGQL_Data(BaseModel):
    viewer: ListingResponseGQL_Data_Viewer

class ListingResponseGQL(BaseModel):
    data: ListingResponseGQL_Data
