from datetime import datetime
from typing import Dict, List, Optional, List, Generic, TypeVar
from pydantic import BaseModel
from pydantic.generics import GenericModel

class ProductVariant_Traits(BaseModel):
    size: str
    sizeDescriptor: str


class ProductVariant_Product_Media(BaseModel):
    thumbUrl: str

class ProductVariant_Product(BaseModel):
    contentGroup: str
    id: str
    media: ProductVariant_Product_Media
    minimumBid: int
    model: str
    name: str
    productCategory: str
    restock: bool
    styleId: str
    urlKey: str
    uuid: str


class ProductVariant_Market_Bid_Ask_Data(BaseModel):
    highestBid: int
    lowestAsk: int

class ProductVariant_Market(BaseModel):
    bidAskData: ProductVariant_Market_Bid_Ask_Data

class ProductVariant(BaseModel):
    id: str
    market: ProductVariant_Market

