import random
from fake_useragent import UserAgent
from .user_agent_fallback import get_random_user_agent as get_random_user_agent_fallback


def get_random_user_agent() -> str:
    try:
        ua = UserAgent()
        browsers = [ua.opera, ua.chrome, ua.google, ua.firefox, ua.ff, ua.safari]
        return random.choice(browsers)
    except Exception as e:
        print(e)
        user_agent_fallback = get_random_user_agent_fallback()
        print(f'falling back to random user agent, selected: {user_agent_fallback}')
        return user_agent_fallback